import { Sequence, GenIterable, Maybe, LazyIterable, ChainFunction } from './util/types';
export declare class ImplSequence<T> implements Sequence<T> {
    private i;
    private _iterator;
    constructor(i: LazyIterable<T>);
    private get iter();
    private get iterator();
    private inject;
    private chain;
    [Symbol.iterator](): Iterator<T, any, undefined> | IterableIterator<T>;
    next(): IteratorResult<T>;
    filter(fnFilter: (t: T) => boolean): ImplSequence<T>;
    skip(n: number): ImplSequence<T>;
    take(n: number): ImplSequence<T>;
    concat(j: Iterable<T>): ImplSequence<T>;
    concatMap<U>(fn: (t: T) => Iterable<U>): ImplSequence<U>;
    combine<U, V>(fn: (t: T, u?: U) => V, j: Iterable<U>): ImplSequence<V>;
    map<U>(fn: (t: T) => U): ImplSequence<U>;
    scan<U>(fnReduce: (prevValue: U, curValue: T, curIndex: number) => U, initValue: U): ImplSequence<U>;
    pipe<U>(fn: ChainFunction<T, U>): ImplSequence<U>;
    all(fnFilter: (t: T) => boolean): boolean;
    any(fnFilter: (t: T) => boolean): boolean;
    count(): number;
    first(fnFilter: (t: T) => boolean, defaultValue: T): T;
    forEach(fn: (t: T, index: number) => void): void;
    max(fnSelector?: (t: T) => T): Maybe<T>;
    min(fnSelector?: (t: T) => T): Maybe<T>;
    reduce<U>(fnReduce: (prevValue: U, curValue: T, curIndex: number) => U, initValue?: U): U;
    reduceToSequence<U>(fnReduce: (previousValue: GenIterable<U>, currentValue: T, currentIndex: number) => GenIterable<U>, initialValue: GenIterable<U>): ImplSequence<U>;
    toArray(): T[];
    toIterable(): Generator<T, void, undefined>;
}
